﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using AcadApp = Autodesk.AutoCAD.ApplicationServices;
using AcApp = Autodesk.AutoCAD.ApplicationServices;
using AcDb = Autodesk.AutoCAD.DatabaseServices;
using AcEditor = Autodesk.AutoCAD.EditorInput;
using AcRuntime = Autodesk.AutoCAD.Runtime;
using Res = Export3dSolids.Properties.Resources;


namespace Export3dSolids.ToolMain
{
    public class mInitialize : AcRuntime.IExtensionApplication
    {
        #region Assembly-Informationen
        static protected string ApplicationName = "";
        static protected string ApplicationLocation = "";
        static protected string ApplicationFilenBaseName = "";
        static protected List<string> CommandsGlobal = new List<string>();
        static protected List<string> CommandsLocal = new List<string>();
        static protected List<string> CommandGroups = new List<string>();
        #endregion Assembly-Informationen

        #region Programm-Informationen
        protected const String _Company = "CAD on demand GmbH";
        protected const String _ApplicationNameDisplayed = "Export3dSolids - ... ";
        private static List<String> _CommandsDisplayed = new List<string>();
        public static volatile String _AutoCADVersion = "";
        #endregion Programm-Informationen
        public void Initialize()
        {
            //AutoCAD-Version setzen
            if (_AutoCADVersion == "") _AutoCADVersion = AutoCADversion.Version;
            // Spracheinstellung
            LanguageHandling.SetCurrentLanguageRessources();
            AssemblyInfo.AssemblyInfo _assemI = new AssemblyInfo.AssemblyInfo();
            RegistryUpdate.CreateDemandLoadingEntries(ApplicationName, ApplicationLocation + ApplicationFilenBaseName + ".dll", CommandsGlobal, CommandsLocal, CommandGroups, 2, true);

            #region Befehle und deren Beschreibung festlegen
            Dictionary<string, string> _commands = new Dictionary<string, string>();

            _commands.Add(commands.cmdExport3dSolids, commands.cmdExport3dSolids_Description);
            //
            _commands.Add(commands.cmdExport3dSolidsUnregister, commands.cmdExport3dSolidsUnregister_Description);
            

            foreach (KeyValuePair<string, string> _ci in _commands)
                _CommandsDisplayed.Add(_ci.Key + " -> " + _ci.Value);
            _CommandsDisplayed.Add("-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+");

            #endregion Befehle und deren Beschreibung festlegen
            #region Ausgabe der Message beim Laden
            AcDb.Database _db = AcDb.HostApplicationServices.WorkingDatabase;
            AcApp.Document _doc = AcApp.Application.DocumentManager.MdiActiveDocument;
            AcEditor.Editor _ed = _doc.Editor;
            _ed.WriteMessage("\n-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+");
            _ed.WriteMessage("\n" + _Company);
            _ed.WriteMessage("\n" + _ApplicationNameDisplayed);
            foreach (String _cmd in _CommandsDisplayed)
            {
                _ed.WriteMessage("\n" + _cmd);
            }
            _ed.WriteMessage("\n-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+");
            #endregion Ausgabe der Message beim Laden
            
            #region -> TrustedPath setzen
            try
            {
                if (AcadApp.Application.GetSystemVariable("TRUSTEDPATHS") != null)
                {
                    String _ToAddPath = ApplicationLocation;
                    _ToAddPath += _ToAddPath.EndsWith("\\") ? "" : "\\";
                    String _trustedPathsVar = AcadApp.Application.GetSystemVariable("TRUSTEDPATHS").ToString().ToUpper();
                    String[] _trustedPaths = _trustedPathsVar.Split(';');
                    Boolean _TrustedContains = false;
                    foreach (String _path in _trustedPaths)
                    {
                        String _vgl = _path.EndsWith("\\") ? _path : (_path + "\\");
                        if (_vgl == _ToAddPath.ToUpper())
                        { _TrustedContains = true; break; }
                    }
                    if (!_TrustedContains)
                    {
                        _trustedPathsVar += _trustedPathsVar.EndsWith(";") ? "" : ";";
                        _trustedPathsVar += _ToAddPath;

                        AcadApp.Application.SetSystemVariable("TRUSTEDPATHS", _trustedPathsVar);
                    }
                }
            }
            catch { }
            #endregion <- TrustedPath setzen

        }


        public void Terminate()
        {

        }

    }
}
