﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;


#if AUTOCAD
using Autodesk.AutoCAD.AcInfoCenterConn;
using Autodesk.Internal.InfoCenter;
using AcadApp = Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;

using AcRx = Autodesk.AutoCAD.Runtime;
using AcRuntime = Autodesk.AutoCAD.Runtime;
using AcApp = Autodesk.AutoCAD.ApplicationServices;
using AcDb = Autodesk.AutoCAD.DatabaseServices;
using AcGeometry = Autodesk.AutoCAD.Geometry;
using AcEditor = Autodesk.AutoCAD.EditorInput;
using AcGui = Autodesk.AutoCAD.GraphicsInterface;
using AcColors = Autodesk.AutoCAD.Colors;
using AcColor = Autodesk.AutoCAD.Colors.Color;
using AcWnd = Autodesk.AutoCAD.Windows;
#endif

#if BRICSCAD
using AcRx = Bricscad.Runtime;
using AcRuntime = Teigha.Runtime;
using AcApp = Bricscad.ApplicationServices;
using AcDb = Teigha.DatabaseServices;
using AcEditor = Bricscad.EditorInput;
using AcColors = Teigha.Colors;
using AcColor = Teigha.Colors.Color;
using AcWindows = Bricscad.Windows;
using AcGui = Teigha.GraphicsInterface;
using AcGeometry = Teigha.Geometry;
#endif

#if ZWCAD
using AcRx = ZwSoft.ZwCAD.Runtime;
using AcRuntime = ZwSoft.ZwCAD.Runtime;
using AcApp = ZwSoft.ZwCAD.ApplicationServices;
using AcDb = ZwSoft.ZwCAD.DatabaseServices;
using AcEditor = ZwSoft.ZwCAD.EditorInput;
using AcColors = ZwSoft.ZwCAD.Colors;
using AcColor = ZwSoft.ZwCAD.Colors.Color;
using AcWindows = ZwSoft.ZwCAD.Windows;
using AcGui = ZwSoft.ZwCAD.GraphicsInterface;
using AcGeometry = ZwSoft.ZwCAD.Geometry;
using ZwSoft.ZwCAD.DatabaseServices;
#endif

namespace Export3dSolids.ToolMain
{

    internal class LanguageHandling
    {
        internal static void SetCurrentLanguageRessources()
        {
            //RegistryKey hive = Microsoft.Win32.Registry.CurrentUser;
            //// Open the main AutoCAD (or vertical) and "Applications" keys
            //String ackString = "";
            //if (AcDb.HostApplicationServices.Current.GetType().GetProperty("RegistryProductRootKey") != null)
            //    ackString = AcDb.HostApplicationServices.Current.GetType().GetProperty("RegistryProductRootKey").GetValue(AcDb.HostApplicationServices.Current, null).ToString();
            //else
            //    ackString = AcDb.HostApplicationServices.Current.GetType().GetProperty("MachineRegistryProductRootKey").GetValue(AcDb.HostApplicationServices.Current, null).ToString();
            //RegistryKey ack = hive.OpenSubKey(ackString, true);

            //using (ack)
            //{
#if AUTOCAD
            CultureInfo _cCulture = new CultureInfo(AcRuntime.SystemObjects.DynamicLinker.ProductLcid);
#endif
#if BRICSCAD
            RegistryKey hive = Microsoft.Win32.Registry.CurrentUser;
            String ackString = "";
            if (AcDb.HostApplicationServices.Current.GetType().GetProperty("RegistryProductRootKey") != null)
                ackString = AcDb.HostApplicationServices.Current.GetType().GetProperty("RegistryProductRootKey").GetValue(AcDb.HostApplicationServices.Current, null).ToString();
            else
                ackString = AcDb.HostApplicationServices.Current.GetType().GetProperty("MachineRegistryProductRootKey").GetValue(AcDb.HostApplicationServices.Current, null).ToString();
            String[] _splitted = ackString.Split('\\');
            CultureInfo _cCulture = new CultureInfo("de-DE");
            if (!_splitted.Last().ToUpper().StartsWith("DE"))
                _cCulture = new CultureInfo("en-US");
#endif
#if ZWCAD
            CultureInfo _cCulture = new CultureInfo(AcRuntime.SystemObjects.DynamicLinker.ProductLcid);
#endif
            if (_cCulture.Name.ToUpper().StartsWith("DE"))
            {//German
                Export3dSolids.Resources.Res.Culture = System.Globalization.CultureInfo.CreateSpecificCulture("de-DE");
                //Export3dSolids.Lizenz.CommonRes.Culture = System.Globalization.CultureInfo.CreateSpecificCulture("de-DE");
            }
            else
            {//other in english
                Export3dSolids.Resources.Res.Culture = System.Globalization.CultureInfo.CreateSpecificCulture("en-US");
                //Export3dSolids.Lizenz.CommonRes.Culture = System.Globalization.CultureInfo.CreateSpecificCulture("en-US");
            }
        }

    }
}
